/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.sc.cse;

import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;


/**
 *
 * @author jmvidal
 */
public class AjaxLookupServlet extends HttpServlet {

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        String responseString = null;
        String username = request.getParameter("username");
        String type = request.getParameter("type");

        int typeInt = Integer.parseInt(type);

        if (username != null) {
            switch (typeInt) {

                case 1:
                    List list = completeUsername(username);
                    responseString = JSONUtil.buildJSONArray(list, "usernames");

                    break;
                case 2:
                    HashMap customer = getCustomerInfo(username);
                    responseString = JSONUtil.buildJSON(customer, "customer");
                    break;

                case 3:
                    responseString = getAllUsers();

                    System.out.println("response: " + responseString);
            }
        }
        if (responseString != null) {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
            response.getWriter().write(responseString);
        } else {
            // If key comes back as a null, return a question mark.
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
            response.getWriter().write("?");
        }

    }

    private List completeUsername(String username) {
        Connection con = DatabaseConnector.getConnection();
        ArrayList usernameList = new ArrayList();
        ResultSet result = null;
        try {
            Statement select = con.createStatement();
            result = select.executeQuery("SELECT USERNAME from USERS where USERNAME like '" + username + "%';");
            while (result.next()) {
                usernameList.add(result.getString("username"));
            }
        } catch (SQLException e) {
        } finally {
            if (con != null) {
                try {
                    con.close();
                } catch (SQLException e) {
                }

            }
        }
        return usernameList;
    }

    private String getAllUsers() {
        Connection con = DatabaseConnector.getConnection();
        ResultSet result = null;
        StringBuffer returnSB = null;
        try {
            Statement select = con.createStatement();
            result = select.executeQuery("SELECT USERNAME from USERS;");
            returnSB = new StringBuffer();
            while (result.next()) {
                returnSB.append(result.getString("username") + ",");
            }
            returnSB.deleteCharAt(returnSB.length() - 1);
        } catch (SQLException e) {
        // You could pop up a window with AJAX to let users know there is a
        // problem.
        } finally {
            if (con != null) {
                try {
                    con.close();
                } catch (SQLException e) {
                }

            }
        }
        return returnSB.toString();
    }

    private HashMap getCustomerInfo(String username) {
        Connection con = DatabaseConnector.getConnection();
        ResultSet result = null;
        HashMap map = new HashMap();
        // preload the map with empty strings.
        map.put("email", "");
        map.put("name", "");
        map.put("address", "");
        map.put("city", "");
        map.put("state", "");
        map.put("zipcode", "");

        try {
            Statement select = con.createStatement();
            result = select.executeQuery("SELECT * from USERS where USERNAME = '" + username + "';");
            String name = null;
            String value = null;
            if (result != null && result.next()) {
                ResultSetMetaData metaData = result.getMetaData();
                for (int i = 1; i <= metaData.getColumnCount(); i++) {
                    name = metaData.getColumnName(i);
                    value = result.getString(name);
                    loadMap(map, name, value);
                }
            }
        } catch (SQLException e) {
            return map;
        } finally {
            if (con != null) {
                try {
                    con.close();
                } catch (SQLException e) {
                }

            }
        }
        return map;
    }

    private void loadMap(HashMap map, String key, String value) {
        map.put(key, value == null ? "?" : value);

    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
