/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.sc.cse;

import java.io.*;
import java.net.*;
import java.sql.*;
import java.util.HashMap;

import javax.servlet.*;
import javax.servlet.http.*;

/**
 *
 * @author jmvidal
 */
public class AjaxZipCodesServlet extends HttpServlet {
   
    /** 
    * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
    * @param request servlet request
    * @param response servlet response
    */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
         String responseString = null;

        String zipCode = request.getParameter("zip");
        if (zipCode != null)
        {
            HashMap location = getCityState(zipCode);
            responseString = JSONUtil.buildJSON(location, "location");
        }
        if (responseString != null)
        {
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
            response.getWriter().write(responseString);
        } else
        {
            // If key comes back as a null, return a question mark.
            response.setContentType("text/xml");
            response.setHeader("Cache-Control", "no-cache");
            response.getWriter().write("?");
        }
    }
    
        private HashMap getCityState(String zipCode)
    {
        Connection con = DatabaseConnector.getConnection();
        HashMap cityStateMap = new HashMap();
        cityStateMap.put("zip", "zipCode");
        String queryString = "";
        try
        {
            queryString = "SELECT CITY, STATE FROM ZIPCODES where ZIPCODE='"
                + zipCode + "'";
            Statement select = con.createStatement();
            ResultSet result = select
                    .executeQuery(queryString);

            while (result.next())
            { // process results one row at a time
                String city;
                String state;

                city = result.getString("CITY");
                if (result.wasNull())
                {
                    city = "";
                }
                cityStateMap.put("city", city);
                state = result.getString("state");
                if (result.wasNull())
                {
                    state = "";
                }
                cityStateMap.put("state", state);
            }
        } catch (Exception e)
        {
            System.out.println("exception caught getting city/state:"+queryString+" "+e.getMessage());
        } finally
        {
            if (con != null)
            {
                try
                {
                    con.close();
                } catch (SQLException e) {
                }
            }
        }
        return cityStateMap;
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
    * Handles the HTTP <code>GET</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
    * Handles the HTTP <code>POST</code> method.
    * @param request servlet request
    * @param response servlet response
    */
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
    * Returns a short description of the servlet.
    */
    public String getServletInfo() {
        return "Short description";
    }
    // </editor-fold>
}
